freeslot("MT_SHADOWBOOST", "sfx_shbost")

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and (player.cmd.buttons & BT_CUSTOM2)
and not player.shadowboost
and player.shadowboostgauge > 0
and not player.powers[pw_carry]

S_StartSound(player.mo, sfx_shbost)
end
end)

addHook("PlayerThink", function(player)
if player.shadowboostgauge == nil then player.shadowboostgauge = 100 return end
if player.mo.skin == "shadow"
and (player.cmd.buttons & BT_CUSTOM2)
and player.shadowboostgauge > 0
and not player.powers[pw_carry]

player.shadowboost = true
local aura = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SHADOWBOOST)
aura.color = SKINCOLOR_RED
aura.angle = player.mo.angle
aura.target = player.mo
aura.tracer = player.mo
aura.scale = player.mo.scale
aura.blendmode = AST_ADD
player.charflags = $|SF_RUNONWATER
if not player.cmd.forwardmove
player.cmd.forwardmove = 60
end
if not (leveltime%4)
player.shadowboostgauge = $-1
end
if player.powers[pw_sneakers]
P_Thrust(player.mo, player.mo.angle, 85*FRACUNIT - player.speed)
elseif not player.powers[pw_sneakers]
P_Thrust(player.mo, player.mo.angle, 65*FRACUNIT - player.speed)
end
end
end)

addHook("MobjThinker", function(mobj)
	if mobj and mobj.target
	   P_MoveOrigin(mobj, mobj.target.x, mobj.target.y, mobj.target.z)
	end
end, MT_SHADOWBOOST)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and (player.cmd.buttons & BT_CUSTOM2)
and player.shadowboost
and P_IsObjectOnGround(player.mo)
and player.mo.state != S_PLAY_RUN

player.mo.state = S_PLAY_RUN
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and not (player.cmd.buttons & BT_CUSTOM2)
and player.shadowboost

player.shadowboost = false
player.charflags = $ & ~SF_RUNONWATER
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and not player.shadowboost
and player.shadowboostgauge < 100
and not (leveltime%32)

player.shadowboostgauge = $+2
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.shadowboost
and player.shadowboostgauge == 0

player.shadowboost = false
player.charflags = $ & ~SF_RUNONWATER
end
end)

addHook("PlayerThink", function(player)
if player.mo.skin == "shadow"
and player.shadowboostgauge >= 100

player.shadowboostgauge = 100
end
end)

addHook("PlayerCanDamage", function(player)
	if (player.mo and player.mo.skin == "shadow")
	and (player.shadowboost)
		return true
	end
end)

addHook ("PlayerThink",function(player)
if player.mo.skin == "shadow"
and (player.shadowboost)

player.powers[pw_strong] = $|STR_ANIM|STR_WALL|STR_SPIKE
end
end)

addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
if source.player and source.skin == "shadow" and target and target.type != MT_PLAYER
source.player.shadowboostgauge = $+5
return false
end
end)

addHook("TouchSpecial", function(mobj, playermobj)
if (playermobj.player.playerstate == PST_DEAD) return end
if mobj and playermobj and playermobj.skin == "shadow" then

playermobj.player.shadowboostgauge = $+3
return false
end
end, MT_RING)

addHook("TouchSpecial", function(mobj, playermobj)
if (playermobj.player.playerstate == PST_DEAD) return end
if mobj and playermobj and playermobj.skin == "shadow" then

playermobj.player.shadowboostgauge = $+3
return false
end
end, MT_COIN)
